import type { Plugin } from 'esbuild';
import { LoadResultCache } from '../load-result-cache';
import { CssUrl } from '../stylesheet-processor';
/**
 * Creates an esbuild {@link Plugin} that loads all CSS url token references using the
 * built-in esbuild `file` loader. A plugin is used to allow for all file extensions
 * and types to be supported without needing to manually specify all extensions
 * within the build configuration.
 *
 * @returns An esbuild {@link Plugin} instance.
 */
export declare function createCssResourcePlugin(url: CssUrl, cache?: LoadResultCache): Plugin;
